unit T_Form;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, ExtCtrls, TeEngine, Series, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    ChangeCheckBox: TCheckBox;
    Chart: TChart;
    HookCheckBox: TCheckBox;
    Series1: THorizBarSeries;
    TopPanel: TPanel;
    procedure ChangeCheckBoxClick(Sender: TObject);
    procedure ChartGetAxisLabel(Sender: TChartAxis; Series: TChartSeries; ValueIndex: Integer;
      var LabelText: string);
    procedure FormCreate(Sender: TObject);
    procedure HookCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  TeeConst;

{$R *.dfm}

procedure TForm1.ChangeCheckBoxClick(Sender: TObject);
begin
  Chart.Repaint;
end;

procedure TForm1.ChartGetAxisLabel(Sender: TChartAxis; Series: TChartSeries; ValueIndex: Integer;
  var LabelText: string);
begin
  if not ChangeCheckBox.Checked then
    Exit;
  if not Assigned(Series) then
    Exit;
  if (Sender = Chart.CustomAxes[0]) then
    // Length
    LabelText := Series.XValueToText(Series.XValue[ValueIndex])
  else if (Sender = Chart.CustomAxes[1]) then
    // Percent of total length (or max bin)
    if Series.MaxXValue <= 0 then
      LabelText := '0'
    else
      LabelText := FormatFloat(Series.PercentFormat, //
        Series.XValue[ValueIndex] / Series.MaxXValue * {Percent} 100);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := Format('TeeChart %s', [TeeConst.TeeMsg_Version]);
end;

procedure TForm1.HookCheckBoxClick(Sender: TObject);
var
  IsActive: Boolean;
begin
  IsActive := HookCheckBox.Checked;
  if IsActive then
    Chart.OnGetAxisLabel := ChartGetAxisLabel
  else
    Chart.OnGetAxisLabel := nil;
  ChangeCheckBox.Visible := IsActive;
  Chart.Repaint;
end;

end.
